 :- dynamic
    reward/1,
    varCount/1,
    actionList/3,
    debug/1,
    domainConsts/1,
    modelchecking/0,
    lastround/0,
    dontstdapart/0,
    nf3579/2,
    ss3579/5,
    reach3579/6,
    notrel3579/4,
    regvf3579/2,
    indexCount/1,
    plan/1,
    timeR1135793579/1,
    interpretations3579/2.

:- use_module(library(ordsets)).
:- use_module(library(system)).
:- use_module(library(random)).



mklist(Val,0,L,L).
mklist(Val,N,L1,L) :- N1 is N-1, L2=[Val|L1], mklist(Val,N1,L2,L).


vi(X) :-
    rewardList(RL),
    length(RL, RLlen), !,
    (integer(X),mklist(X,RLlen,[],I),!;I=X),
    length(I, RLlen),
     all_rewds(I, RL).



getIListSubset(_, [], []).
getIListSubset(Dom, [Ex | IList], [Ex2 | Rest]) :-
%    length(IList, L),
%%    random(0, L, R),
%    R = 0,
%    nth0(R, IList, Ex),
%    del(Ex, IList, IList1),
    completeStateDescription(Ex, Dom, Ex1),
    convert_Ex(Ex1, Ex2),
%    Ex2 = Ex1,
    getIListSubset(Dom, IList, Rest).


    
all_rewds([], []) :- 
    !.
all_rewds([X | Other], [Rewd1 | Rest]) :-
    asserta(plan(X)),
    asserta(Rewd1),
    getRewdPred(RewdPred),
    (retract(interpretations3579(RewdPred, IList)),
     interpretationObjs3579(RewdPred, Dom),
     getIListSubset(Dom, IList, IList1),
     asserta(interpretations3579(RewdPred, IList1))
     ;
     true),
    valueIterate(X, _),
    retract(Rewd1),
    retract(plan(_)),
    all_rewds(Other, Rest).




valueIterate(N, VF) :- 
    reward(Rewd),
    write('Reward Function:'), nl, pp(Rewd),
    retract(domainConsts(DomConsts)),
    sort(DomConsts, DomConsts1),
    getDVarsConsts(Rewd, [], RewFnVarsConsts),
    extractVarsFromVarConsts(RewFnVarsConsts, RewFnVars),
    diff(RewFnVarsConsts, RewFnVars, RewdFnConsts),
    (getIListObjs(IListObjs) ; IListObjs = []),
    conc(RewdFnConsts, IListObjs, AllConsts),
    batchInsertRev(AllConsts, DomConsts1, DomConsts2),
    asserta(domainConsts(DomConsts2)),
    (RewFnVars = [] -> Max = 0 ; lastElem(RewFnVars, Max1), name(Max1, [118 | M]), name(Max, M)),
    InitCount is Max + 1,
    asserta(varCount(InitCount)),
    Discount = 0.9,
    ops(OpList),
    getVF(Rewd, N, Discount, OpList, Rewd, RewFnVars, VF),
    retract(varCount(_)). 







getVF(VF, 0, _, _, _, _, VF) :- 
	pp(VF),nl,nl,
    !.
getVF(VF, Rounds, Discount, OpList, Rewd, RewdVars, RefVF) :-     
    write(Rounds), write(' to go !!'), nl,
    getDVars(VF, VFvars),
    (once((plan(Xrounds), switch(Yrounds), DiffRounds is Xrounds - Yrounds)), Rounds = DiffRounds, asserta(dontstdapart) ; write('Not Yet'), nl, true),

    (Rounds == 1, 
     getRewdConjVar([Goal], GoalKey)
     ;
     Goal = 1,
     GoalKey = 1),
    
    regress(Rounds, VF, VFvars, Goal, GoalKey, [], [], OpList, RegVF),
    (debug(main1) -> (write('Maximized over the actions:'), nl, pp(RegVF)) ; true), 

    (modelcheckingnode, NextVF1 = RegVF ; r11(RegVF, NextVF1)),
    (debug(main1) -> (write('Multiplied by discount factor 0.9 and added Rewd Function:'), nl, pp(NextVF1)) ; true),
    !,
    Rounds1 is Rounds - 1,
    getDVars(NextVF1, NextVars),
    retract(varCount(_)),
    asserta(varCount(1)),
    stdApart1(NextVF1, NextVars, NextVF), 
    !,
    pp(NextVF), nl, nl, 
    getVF(NextVF, Rounds1, Discount, OpList, Rewd, RewdVars, RefVF).





stdApart(D, _, D).

stdApart1(D, Dvars, R) :- 
    retract(varCount(Start)),
    length(Dvars, Len),
    getNewVars(Start, Len, NewVars),
    Start1 is Start + Len,
    assert(varCount(Start1)),
    getGroundKey(Dvars, NewVars, Key),
    variablizeDD(D, Key, R).






objMax(VF, Action, ActParams, NewAction, ObjMaxVF) :- 
    sort(ActParams, ActParams1),
    length(ActParams1, Len),    
    retract(varCount(Start)),
    getNewVars(Start, Len, NewVars),
    Start1 is Start + Len,
    assert(varCount(Start1)),
    getGroundKey(ActParams1, NewVars, Key),
    variablizeTerm(Action, Key, NewAction), 
    variablizeDD(VF, Key, ObjMaxVF).
 




r9r8Cycle(D, ReducedD) :- 
    retractall(nf3579(_, _)),
    retractall(ss3579(_, _, _, _, _)),
    retractall(reach3579(_, _, _, _, _, _)), 
    retractall(notrel3579(_, _, _, _)),
    asserta(indexCount(2)),
    r9(D, Dn),
%	write('After r10: '), pp(Dn),
    r92(Dn, D1),
%	write('After r92: '),	pp(D1),
    retractall(indexCount(_)),
     retractall(nf3579(_, _)),     
       r81(D1, D2),
%	write('After r9: '), pp(D2),
     ((D = D2) -> (ReducedD = D2)
      ;
      r9r8Cycle(D2, ReducedD)).




r7r8Cycle(D, ReducedD) :- 
    retractall(nf3579(_, _)),
    retractall(ss3579(_, _, _, _, _)),
    retractall(reach3579(_, _, _, _, _, _)), 
    retractall(notrel3579(_, _, _, _)),
    asserta(indexCount(2)),
    r7(D, D1),    
    retractall(indexCount(_)),
    (D = D1 -> (ReducedD = D1)
     ;
     retractall(nf3579(_, _)),

     r81(D1, D2),
     (D1 = D2 -> (ReducedD = D2)
      ;
      r7r8Cycle(D2, ReducedD))).
    




reduce(D, ReducedD) :- 
    modelchecking,
    !,
    reduce2(D, ReducedD),
    !.
reduce(D, ReducedD) :- 
    reduce1(D, ReducedD).



reduce2(D, ReducedD) :-
    r13(D, ReducedD).


reduce1(D, ReducedD) :- 
    (r7on, 
     !,
     r7r8Cycle(D, ReducedD)
     ;
     r9r8Cycle(D, ReducedD)),
    retractall(nf3579(_, _)),
    retractall(ss3579(_, _, _, _, _)),
    retractall(reach3579(_, _, _, _, _, _)),
    retractall(notrel3579(_, _, _, _)).




post_process_policy_paths([], _, []) :- 
       !.
post_process_policy_paths([path(_, _, _, Path) | Rest], Goal, Res) :- 
       once(copy_term(Goal, Goal1)),
       subsumes2(Goal1, Path),
       post_process_policy_paths(Rest, Goal, Res),
       !.
post_process_policy_paths([path(N, L, EL, Path) | Rest], Goal, [path(N, L, EL, Path) | Res]) :- 
       post_process_policy_paths(Rest, Goal, Res).




max_over_actions([], VF, VF) :-
    !.
max_over_actions([First | ActionList], SoFar, VF) :-
    SoFar = [Rootsf | VFsofar],
    First = [Root | ReducedVF],
    (debug(main1) -> (write('First: '), nl, pp(First), nl) ; true),
    (debug(main1) -> (write('SoFar: '), nl, pp(SoFar), nl) ; true),
    apply(Rootsf, [Rootsf | VFsofar], Root, [Root | ReducedVF], max, NewVFsofar1), 
    (debug(main1) -> (write('Max Over Actions in Progress'), nl, pp(NewVFsofar1), nl) ; true), 
    (debug(main1) -> write('So Far now: '), nl, write(NewVFsofar1), nl  ; true),
    reduce(NewVFsofar1, NewVFsofar),
    (debug(main1) -> write('Max Reduced: '), write(Op), write(':  '), write(NewVFsofar), nl ; true),
    max_over_actions(ActionList, NewVFsofar, VF).
    




regress(Round, _, _, _, _, ActionList, ActionRules, [], VF) :-
    ActionList = [First | ActionList1],
    (Round == 1, 
     VF = [node(0, 0.0, -1, -1)] ; max_over_actions(ActionList1, First, VF)),
    !.
regress(Round, VF, VFvars, GoalVar, GoalKey, Actionsofar, ActionRulesSoFar, [Op | OpList], RegVF) :- 
    operator(Op, ActParams, [CostRoot | Cost], EventList),
    actionDiagParams(AllActParams),
    Action =.. [Op | ActParams],
    (debug(main1) -> write(Op), nl ; true),
    varCount(Start),
       
    regressOverOp(VF, VFvars, Op, [node(0, 0.0, -1, -1)], EventList, RegOpVF),
    RegOpVF = [RegOpRoot | _],
    most_action_variants(MAV),
    length(VFvars, VFvarsLen),
    Start1 is Start + (MAV * VFvarsLen),
    retract(varCount(_)), asserta(varCount(Start1)),
    (debug(main1) -> (write(Op), write(' variants added:'), nl, pp(RegOpVF)) ; true),
    getRewdPred(RewdPred),
    (discountfactor(RewdPred, Op, DDD); DDD= 0.999),
    apply(RegOpRoot, RegOpVF, node(2, DDD, -1, -1), [node(2, DDD, -1, -1)], *, [DiscRoot | DiscountedVF]),

    reward(Rewd),
    getDVars(Rewd, RewdVars),
    stdApart1(Rewd, RewdVars, [RewdRoot | Rfn]),
    apply(DiscRoot, [DiscRoot | DiscountedVF], RewdRoot, [RewdRoot | Rfn], max, [ObjMaxRoot1 | ObjMaxVF1]),

    apply(ObjMaxRoot1, [ObjMaxRoot1 | ObjMaxVF1], CostRoot, [CostRoot | Cost], -, CostRedVF), 
       
    (once((Round == 1)),
     not(reducedqfunction3579),
     FinalVF = CostRedVF,
     FinalAction = Action,
     FinalActionParams = ActParams
     ;
     objMax(CostRedVF, Action, AllActParams, NewAction, ObjMaxVF),
     !,
     FinalAction = NewAction,
     NewAction =.. [_ | FinalActionParams],
     (debug(main1) -> (write('before adding the rewd function :'), nl, pp(ObjMaxVF)) ; true),
     reduce(ObjMaxVF, ReducedVF1),
     (debug(main1) -> write('RedVF after node removal: '), nl, pp(ReducedVF1), nl ; true),
     (modelcheckingnode, ReducedVF = ReducedVF1 ; r11(ReducedVF1, ReducedVF)),
     FinalVF = ReducedVF),
    
    (once((Round == 1)),
     FinalVF = [node(FinalRoot, _, _, _) | _],     
     getDVars(FinalVF, FinalVars),
     getSubsKey(FinalActionParams, ActParamsKey),
     getSubsKey(FinalVars, FinalVarsKey),
     conc(ActParamsKey, GoalKey, ActGoalKey),
     conc(ActGoalKey, FinalVarsKey, Key),
     variablizeTerm(FinalAction, Key, ActionVar),
     variablizeDD(FinalVF, Key, FinalVarVF),
     get_paths(FinalRoot, FinalVarVF, [], [], Paths1),
     (postprocesspolicy3579,
      !,
      post_process_policy_pathsRoni(ActionVar,Paths1, [GoalVar], ProcPaths1)
      ;
      add_action_to_paths(ActionVar, Paths1, ProcPaths1)),
     sort(ProcPaths1, Paths3)
     ;
     true),

     (once((Round == 1)),
      (policyrules3579,
       
       merge(ActionRulesSoFar, Paths3, ActionRulesSoFar1),
       (OpList == [],
	reverse(ActionRulesSoFar1, Paths),
	outpolicyfile3579(OPF),
	open(OPF, append, S), 
	tell(S),
	write(actionList(GoalVar, Paths)),write('.'), nl, nl, nl,
	close(S)     	
	;
	true)
       ;
       ActionRulesSoFar1 = ActionRulesSoFar,
       reverse(Paths3, Paths),
       outpolicyfile3579(OPF),
       open(OPF, append, S), 
       tell(S),
       write(actionList(ActionVar, GoalVar, Paths)),write('.'), nl, nl, nl,
       close(S))     
       ;
       ActionRulesSoFar1 = ActionRulesSoFar),

    (debug(main1) -> write('RedVF: '), pp(FinalVF), nl ; true),
    retract(varCount(_)), asserta(varCount(Start)),
    !,
    regress(Round, VF, VFvars, GoalVar, GoalKey, [ReducedVF | Actionsofar], ActionRulesSoFar1, OpList, RegVF).
    


    

regressOverOp(_, _, _, RegOpVF, [], RegOpVF) :- 
    !.
regressOverOp(VFraw, VFvars, Op, [Rootsf | VFsofar], [ev(Event, [ProbRoot | ProbDD]) | EventList], RegOpVF) :- 
    (dontstdapart, stdApart(VFraw, VFvars, [node(I, Lit, L, R) | VF]) ; stdApart1(VFraw, VFvars, [node(I, Lit, L, R) | VF])),
    getRegressedVF(I, [node(I, Lit, L, R) | VF], Op, Event, [Root1 | RegVF1]),
    !,     
    retractall(regvf3579(_, _)),
    (debug(main1) -> (write(Op), write(' '), write(Event), write('  regressed'), nl, pp([Root1 | RegVF1])) ; true),
    apply(Root1, [Root1 | RegVF1], ProbRoot, [ProbRoot | ProbDD], *, [Root | RegVF]),
    !,
    (debug(main) -> (write('probability multiplied'), nl, write([Root | RegVF]), nl, pp([Root | RegVF])) ; true),
    apply(Rootsf, [Rootsf | VFsofar], Root, [Root | RegVF], +, NewVFsofar1),
    (debug(main) -> (write(Op), write(' intermediate variants added'), nl, pp(NewVFsofar1)) ; true),
    NewVFsofar = NewVFsofar1,
    (debug(main1) -> write('So Far Reduced to see the problem'), nl, write(NewVFsofar), nl ; true),  
    regressOverOp(VFraw, VFvars, Op, NewVFsofar, EventList, RegOpVF).
    






negateTVD([], []) :- 
    !.
negateTVD([node(1, 1.0, -1, -1) | Rest], [node(0, 0.0, -1, -1) | NegRest]) :-
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(0, 0.0, -1, -1) | Rest], [node(1, 1.0, -1, -1) | NegRest]) :-
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, 0, 1) | Rest], [node(I, Lit, 1, 0) | NegRest]) :- 
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, 1, 0) | Rest], [node(I, Lit, 0, 1) | NegRest]) :- 
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, 0, R) | Rest], [node(I, Lit, 1, R) | NegRest]) :- 
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, 1, R) | Rest], [node(I, Lit, 0, R) | NegRest]) :- 
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, L, 0) | Rest], [node(I, Lit, L, 1) | NegRest]) :- 
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, L, 1) | Rest], [node(I, Lit, L, 0) | NegRest]) :- 
    negateTVD(Rest, NegRest),
    !.
negateTVD([node(I, Lit, L, R) | Rest], [node(I, Lit, L, R) | NegRest]) :- 
    negateTVD(Rest, NegRest).
    





extractDomConsts([], [], []) :- 
    !.
extractDomConsts([X | Rest], [X | RestDC], RestVarPars) :- 
    domConst(X),
    extractDomConsts(Rest, RestDC, RestVarPars),
    !.
extractDomConsts([X | Rest], RestDC, [X | RestVarPars]) :- 
    extractDomConsts(Rest, RestDC, RestVarPars).



getOrderNums(Count, Count, [Count]) :- 
    !.
getOrderNums(Start, Count, [Start | Rest]) :- 
    Start1 is Start + 1,
    getOrderNums(Start1, Count, Rest).




getArgOrder([], []) :- 
    !.
getArgOrder([X], [1]) :- 
    !.
getArgOrder(LitParams, ArgOrder) :- 
    extractDomConsts(LitParams, DomConsts, VarPars),
    sort(DomConsts, SortedDomConsts),
    sort(VarPars, SortedVarPars),
    conc(SortedDomConsts, SortedVarPars, SortedLitParams),
    length(SortedLitParams, Len),
    getOrderNums(1, Len, Nums),
    getGroundKey(SortedLitParams, Nums, Key),
    variablizeNumList(LitParams, Key, ArgOrder).
    



getRegressedVF(I, VF, _, _, [node(I, N, -1, -1)]) :- 
    member(node(I, N, -1, -1), VF),
    !.
getRegressedVF(I, _, _, _, RegVF) :- 
    regvf3579(I, RegVF),
    !.
getRegressedVF(I, VF, Op, Event, RegVF) :- 
    member(node(I, Lit, L, R), VF),
    Lit =.. [Pr | LitParams],
    getArgOrder(LitParams, ArgOrder),
    (tvd(Op, Event, Pr, ObjParams, ArgOrder, Root, TVD1) ; (write(Op), write(' '), write(Event), write(' '), write(Pr), nl, nl), !, fail),
    getGroundKey(ObjParams, LitParams, Key),
    variablizeDD(TVD1, Key, TVD),
    TVD = [node(Root, RootLit, RootL, RootR) | _],
    getRegressedVF(L, VF, Op, Event, [Lroot | LRegVF]),
    getRegressedVF(R, VF, Op, Event, [Rroot | RRegVF]),
    !,
    negateTVD(TVD, NegTVD),
    NegTVD = [node(NegRoot, NegRootLit, NegRootL, NegRootR) | _], 
    apply(node(Root, RootLit, RootL, RootR), TVD, Lroot, [Lroot | LRegVF], *, [Lr | BBL]),
    apply(node(NegRoot, NegRootLit, NegRootL, NegRootR), NegTVD, Rroot, [Rroot | RRegVF], *, [Rr | BBR]),
    apply(Lr, [Lr | BBL], Rr, [Rr | BBR], +, RegVF),
    asserta(regvf3579(I, RegVF)).
    



