
:- dynamic
    hs/0,
    not_hs/0,
    vat/1,
    not_vat/1,
    nft/0,
    not_nft/0,
    sin/1,
    not_sin/1,
    road/2,
    not_road/2,
    eq/2,
    not_eq/2.

templates([hs, not_hs, vat(_x1), not_vat(_x2), nft, not_nft, sin(_x3), not_sin(_x4), road(_x5, _x6), not_road(_x7, _x8), eq(_x9, _x10), not_eq(_x11, _x12)]).

preds([pred(hs, 0), pred(vat, 1), pred(nft, 0), pred(sin, 1), pred(road, 2), pred(eq, 2)]).

predOrder([eq, vat, hs, nft, sin, road]).

%reward([node(3, vat(a), 2, 0), node(2, 500.0, -1, -1), node(0, 0.0, -1, -1)]).
rewardList([reward([node(3, vat(a), 2, 0), node(2, 500.0, -1, -1), node(0, 0.0, -1, -1)])]).




ops([moveCar, loadTire, changeTire]).

operator(moveCar, [xa, xb], [node(0, 0.0, -1, -1)], [ev(succ, [node(2, 0.6, -1, -1)]), ev(fail, [node(2, 0.4, -1, -1)])]).
operator(loadTire, [xa], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).
operator(changeTire, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(2, 0.5, -1, -1)]), ev(fail, [node(2, 0.5, -1, -1)])]).
%operator(changeTire, [], [node(0, 0.0, -1, -1)], [ev(succ, [node(1, 1.0, -1, -1)])]).

actionDiagParams([xa, xb]).

most_action_variants(2).

domainConsts([a]).




testOps([op(moveCar, [loc, loc], class(moveCar(A,B), 0.0, preconds([vat(A), road(A,B), nft]), effects([cond([], [outcome(0.6, addList([vat(B), not_vat(A)]), delList([not_vat(B), vat(A)])), outcome(0.4, addList([vat(B), not_vat(A), not_nft]), delList([vat(A), not_vat(B), nft]))])]))), op(loadTire, [loc], class(loadTire(D), 0.0, preconds([vat(D), sin(D)]), effects([cond([hs], [outcome(1.0, addList([not_sin(D)]), delList([sin(D)]))]), cond([not_hs], [outcome(1.0, addList([hs, not_sin(D)]), delList([not_hs, sin(D)]))])]))), op(changeTire, [], class(changeTire, 0.0, preconds([hs]), effects([cond([nft], [outcome(0.5, addList([not_hs]), delList([hs])), outcome(0.5, addList([]), delList([]))]), cond([not_nft], [outcome(0.5, addList([not_hs, nft]), delList([hs, not_nft])), outcome(0.5, addList([]), delList([]))])])))]).

testPreds([pred(not_vat, [loc]), pred(not_sin, [loc]), pred(not_road, [loc, loc]), pred(not_nft, []), pred(not_hs, [])]).



%%%%%%%%%%%% TVD: MOVECAR SUCCESS %%%%%%%%%%%%%%%

tvd(moveCar, succ, hs, [], [], 2, [node(2, hs, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, succ, vat, [y1], [_], 11, [node(11, eq(y1, xa), 10, 7), node(10, vat(xa), 9, 0), node(9, nft, 8, 1), node(8, road(xa, xb), 0, 1), node(7, eq(y1, xb), 6, 2), node(6, vat(xa), 4, 5), node(5, vat(xb), 1, 0), node(4, nft, 3, 0), node(3, road(xa, xb), 1, 0), node(2, vat(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, succ, nft, [], [], 2, [node(2, nft, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, succ, sin, [y2], [_], 2, [node(2, sin(y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, succ, road, [y3, y4], [_, _], 2, [node(2, road(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, succ, eq, [y5, y6], [_, _], 2, [node(2, eq(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%% TVD: MOVECAR FAILURE %%%%%%%%%%%%%%%

tvd(moveCar, fail, hs, [], [], 2, [node(2, hs, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, fail, vat, [y1], [_], 11, [node(11, eq(y1, xa), 10, 7), node(10, vat(xa), 9, 0), node(9, nft, 8, 1), node(8, road(xa, xb), 0, 1), node(7, eq(y1, xb), 6, 2), node(6, vat(xa), 4, 5), node(5, vat(xb), 1, 0), node(4, nft, 3, 0), node(3, road(xa, xb), 1, 0), node(2, vat(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, fail, nft, [], [], 5, [node(5, vat(xa), 4, 2), node(4, nft, 3, 0), node(3, road(xa, xb), 0, 1), node(2, nft, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, fail, sin, [y2], [_], 2, [node(2, sin(y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, fail, road, [y3, y4], [_, _], 2, [node(2, road(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(moveCar, fail, eq, [y5, y6], [_, _], 2, [node(2, eq(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: LOADTIRE SUCCESS %%%%%%%%%%%%%%%

tvd(loadTire, succ, hs, [], [], 5, [node(5, vat(xa), 4, 2), node(4, hs, 1, 3), node(3, sin(xa), 1, 0), node(2, hs, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(loadTire, succ, vat, [y1], [_], 2, [node(2, vat(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(loadTire, succ, nft, [], [], 2, [node(2, nft, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(loadTire, succ, sin, [y2], [_], 5, [node(5, eq(y2, xa), 4, 2), node(4, vat(xa), 0, 3), node(3, sin(xa), 1, 0), node(2, sin(y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(loadTire, succ, road, [y3, y4], [_, _], 2, [node(2, road(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(loadTire, succ, eq, [y5, y6], [_, _], 2, [node(2, eq(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

%%%%%%%%%%%% TVD: CHANGETIRE SUCCESS %%%%%%%%%%%%%%%

tvd(changeTire, succ, hs, [], [], 0, [node(0, 0.0, -1, -1)]).

tvd(changeTire, succ, vat, [y1], [_], 2, [node(2, vat(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, succ, nft, [], [], 3, [node(3, hs, 1, 2), node(2, nft, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, succ, sin, [y2], [_], 2, [node(2, sin(y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, succ, road, [y3, y4], [_, _], 2, [node(2, road(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, succ, eq, [y5, y6], [_, _], 2, [node(2, eq(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%% TVD: CHANGETIRE FAILURE %%%%%%%%%%%%%%%

tvd(changeTire, fail, hs, [], [], 2, [node(2, hs, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, fail, vat, [y1], [_], 2, [node(2, vat(y1), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, fail, nft, [], [], 2, [node(2, nft, 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, fail, sin, [y2], [_], 2, [node(2, sin(y2), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, fail, road, [y3, y4], [_, _], 2, [node(2, road(y3, y4), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).

tvd(changeTire, fail, eq, [y5, y6], [_, _], 2, [node(2, eq(y5, y6), 1, 0), node(1, 1.0, -1, -1), node(0, 0.0, -1, -1)]).


%%%%%%%%%%%%% GENERAL BACKGROUND KNOWLEDGE %%%%%%%%%%%%%%%%%%%%%%%%

rule(eq(A, B), [1, 1], [eq(B, A)]).
rule(eq(A, B), [1, 1], [eq(C, D), eq(A,C), eq(B,D)]).

rule(not_eq(A, B), [1, 1], [not_eq(B, A)]).
rule(not_eq(A, B), [1, 1], [not_eq(C, D), eq(A,C), eq(B,D)]).


%%%%%%%%%%%%% DOMAIN SPECIFIC BACKGROUND KNOWLEDGE %%%%%%%%%%%%%%%%%%%%%%%%


rule(eq(L1, L2), [1, 1], [vat(L1), vat(L2)]).

rule(not_eq(L1, L2), [1, 1], [vat(L1), not_vat(L2)]).
rule(not_eq(L1, L2), [1, 1], [sin(L1), not_sin(L2)]).
rule(not_eq(L1, L2), [1, 1], [road(L1, L2)]).
rule(not_eq(L1, L2), [1, 1], [road(L3, L1), not_road(L3, L2)]).
rule(not_eq(L1, L2), [1, 1], [road(L1, L3), not_road(L2, L3)]).


rule(vat(L1), [1], [vat(L2), eq(L1, L2)]).
rule(not_vat(L1), [1], [not_vat(L2), eq(L1, L2)]).
rule(not_vat(L1), [1], [vat(L2), not_eq(L1, L2)]).

rule(road(L1, L2), [1, 1], [road(L3, L4), eq(L1, L3), eq(L2, L4)]).
rule(not_road(L1, L2), [1, 1], [not_road(L3, L4), eq(L1, L3), eq(L2, L4)]).









runIt :- initState(S), asserta(debug(8)), plan(S, [vat(n0)], PL).


