

% This file can be used for off line planning and/or for testing a policy by
%  loading appropriate domain definitions and setting parameters

% ----------------------------------------------------------------

% Part I
% Load system code 

%:- yap_flag(language, sicstus).
%:- yap_flag(update_semantics,logical).
:- ensure_loaded('Code/utils.yap').
:- ensure_loaded('Code/thmProver6.yap').
:- ensure_loaded('Code/django.yap').
:- ensure_loaded('Code/dc_subsumption.yap').
:- ensure_loaded('Code/reductionUtils.yap').
:- ensure_loaded('Code/reduce3.yap').
:- ensure_loaded('Code/examplegeneration.yap').
:- ensure_loaded('Code/modelcheckingreductions.yap').
:- ensure_loaded('Code/goal_ordering.yap').
:- ensure_loaded('Code/apply2.yap').
:- ensure_loaded('Code/printfodd.yap').
:- ensure_loaded('Code/map5.yap').
:- ensure_loaded('Code/valueIteration3.yap').
:- ensure_loaded('Code/policyspeedup.yap').
:- ensure_loaded('Code/policyeval.yap').
:- ensure_loaded('reductionResult.yap').

% Uncomment debug with the right argument for debuggin information. 
% (grep for debug in code)
% debug(main1).
% debug(1).
% debug(2).
% debug(_x).

% ----------------------------------------------------------------

% Part II
% load domain definitions 
% set options (and load other domain files if needed for option).
% Uncomment the one used

%:- ensure_loaded('Logistics/logisticsDomain6.pl').
%:- ensure_loaded('Fileworld/fileworldDomain.pl').
%:- ensure_loaded('Boxworld/boxworldDomainDet.pl').
%:- ensure_loaded('Tireworld/tireworldDomain1.pl').






% when testing the following are needed (test problems and policy)
% OK to leave uncommented when off line planning
%:- ensure_loaded('Logistics/logistics_test.pl').
%:- ensure_loaded('Fileworld/fileworld_test.pl').
%:- ensure_loaded('Boxworld/boxworld_test.pl').
%:- ensure_loaded('Tireworld/tireworld_test.pl').




% Part III
% Set options (and load other domain files if needed for option)
% Set system parameters 


% controling theorem proving reductions. The r7on, r11on and r9on are switches
% that need to be uncommented to turn these reductions on. Uncommenting r7on
% will turn off r10 and commenting r7on will turn on r10.

%r7on.
r11on.
r9on.


% ===> THIS IS THE MAIN CONTROL
% if set - off line planning occurs via vi with number of iterations
% if commented out testing will occur
% plan(9).
% the number of iterations to run with standartizing apart
% all -> set same as in plan() or larger; none --> set to 0
switch(0).

% In the following line, X indicates the precision value on the
% leaves. Replace X by that number. E.g. X = 10 will map leaves (except 0.0 and
% 1.0) to their closest multiple of 10. If you do not want the approximation
% of merging leaves, set X to 0.

leafprecision(0).



% In the following line X indicates the parameter 'w' of the weighted goal
% ordering heuristic. 0.0 < w <= 1.0.

wgoparam(1.0).



% When policyrules3579 is on, the policy is written in the form of rules 
% to file and the final iteration is not run to completion
policyrules3579.


% When postprocesspolicy3579 is on, the policy is processed so that rules 
% containing the reward condition are removed and replaced by a single rule. 
postprocesspolicy3579.
postprocesspolicy3579atoms.




testRounds(30).
maxplanningsteps3579(200).




% Part IV

% These are the lines that kick off the planning/execution routines.
% If you are running execution, replace the "exec_out_file" by the 
% file you want to write the output to. 

oldcontrol :-  statistics(cputime, [T1,_]), 
    (plan(X),
     !,
     vi(X)
     ;
     tell('exec_out_file'),
     solve, 
     told),
     statistics(cputime, [T2,_]),
     T3 is T2 - T1,
     write('Total Time Taken: '), write(T3), write(' milliseconds'), nl, nl.


planit(X,PF) :-  
%    asserta(plan(X)),
    tell(PF),
    write('%%% POLICY:'), nl, nl, nl, 
    told,
    asserta(outpolicyfile3579(PF)),
    statistics(cputime, [T1,_]), 
     vi(X),
     statistics(cputime, [T2,_]),
     T3 is T2 - T1,
     write('Total Time Taken: '), write(T3), write(' milliseconds'), nl, nl.

testit(PF) :-  
    ensure_loaded(PF),
    statistics(cputime, [T1,_]), 
     tell('exec_out_file'),
     solve, 
     told,
     statistics(cputime, [T2,_]),
     T3 is T2 - T1,
     write('Total Time Taken: '), write(T3), write(' milliseconds'), nl, nl.

getA(Policy,State,Goal,Action) :-
     ensure_loaded(Policy),
     mygetA(State,Goal,Action),
     write('Chosen Action: '), write(Action),nl.

getApo(Policy,State,Goal,Action) :-
     ensure_loaded(Policy),
     mygetA2(State,Goal,Action),
     write('Chosen Action: '), write(Action),nl.

getApoSet(Policy,State,Goal,Action) :-
     ensure_loaded(Policy),
     mygetA3(State,Goal,Action),
     write('Chosen Action: '), write(Action),nl.

getA2(Policy,State,Goal,Action) :-
     ensure_loaded(Policy),
     mygetA4(State,Goal,Action),
     write('Chosen Action: '), write(Action),nl.



% :- halt.


